'use strict';

/* App Module */

angular.module('app', [
    'ui.bootstrap',
    'ui.router',
    'LocalStorageModule',
    'ngMaterial',
    'md.data.table',
    'sasrio.angular-material-sidenav',
    'luticate2Utils',
    // 'luticateAuth',
    'appSdk'
])
    .config(['$stateProvider', '$urlRouterProvider', 'ssSideNavSectionsProvider', '$mdThemingProvider', '$mdIconProvider',
        function($stateProvider, $urlRouterProvider, ssSideNavSectionsProvider, $mdThemingProvider, $mdIconProvider) {

            // $mdThemingProvider
            //     .theme('default')
            //     .primaryPalette('blue', {
            //         'default': '700'
            //     });

            // $mdThemingProvider.theme('default')
            //     .primaryPalette('blue')
            //     .accentPalette('pink');

            $mdIconProvider
                .icon('md-toggle-arrow', 'img/arrow.svg');

            ssSideNavSectionsProvider.initWithTheme($mdThemingProvider);
            ssSideNavSectionsProvider.initWithSections([{
                id: 'toogle_1',
                name: 'Home',
                type: 'heading',
                children: [{
                    name: 'Home 1',
                    type: 'toggle',
                    pages: [{
                        id: 'toogle_1_link_1',
                        name: 'Home 1 1',
                        state: 'home'
                    }, {
                        id: 'toogle_1_link_2',
                        name: 'Home 1 2',
                        state: 'home.1.2',
                        hidden: true
                    }, {
                        id: 'toogle_1_link_3',
                        name: 'Home 1 3',
                        state: 'home.1.3'
                    }]
                }]
            }, {
                id: 'link_1',
                name: 'Home 2 ',
                state: 'home.2',
                type: 'link',
                icon: 'fa fa-check'
            }, {
                id: 'link_2',
                name: 'Home 3',
                state: 'home.3',
                type: 'link'
            }, {
                id: 'link_3',
                name: 'Link 3',
                state: 'common.link3',
                type: 'link',
                hidden: true
            },  {
                id: 'toogle_2',
                name: 'PkGuid',
                type: 'heading',
                children: [{
                    name: 'PkGuids',
                    type: 'toggle',
                    pages: [{
                        id: 'toogle_2_link_1',
                        name: 'All',
                        state: 'pkguid'
                    },{
                        id: 'toogle_2_link_1',
                        name: 'New',
                        state: 'pkguid_add'
                    }]
                }]
            }]);

            $stateProvider.state('root', {
                abstract: true,
                template: '<div ui-view=""></div>',
                // resolve: ['luticateAuthUsers', function(luticateAuthUsers)
                // {
                //     return luticateAuthUsers.loadUserData(null);
                // }]
            });

            $stateProvider.state('home', {
                url:'/',
                parent: 'root',
                title: "Home",
                reloadOnSearch: false,
                templateUrl:'views/home.html',
                controller:'HomeController'
            });

            $stateProvider.state('pkguid', {
                url:'/pkguids',
                parent: 'root',
                title: "PkGuid",
                reloadOnSearch: false,
                templateUrl:'views/pkguid.html',
                controller:'PkGuidController'
            });

            $stateProvider.state('pkguid_add', {
                url:'/pkguids/add',
                parent: 'root',
                title: "New PkGuid",
                reloadOnSearch: false,
                templateUrl:'views/pkguidedit.html',
                controller:'PkGuidEditController'
            });

            $stateProvider.state('pkguid_edit', {
                url:'/pkguids/edit/:id',
                parent: 'root',
                title: "Edit PkGuid",
                reloadOnSearch: false,
                templateUrl:'views/pkguidedit.html',
                controller:'PkGuidEditController',
                params: {
                    pkguid: null
                }
            });

            $urlRouterProvider.otherwise('/');
    }])
    .directive('dateNow', ['$filter', function($filter) {
        return {
            link: function( $scope, $element, $attrs) {
                $element.text($filter('date')(new Date(), $attrs.dateNow));
            }
        };
    }])
    .run(['$rootScope', '$transitions', function ($rootScope, $transitions) {
        $transitions.onSuccess({}, function($transitions)
        {
            var toState = $transitions.$to();
            $rootScope.title = toState.title + " - App";
        });
    }]);